VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clDirectDraw"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
'WIN32 API SECTION
Private Declare Function BitBlt Lib "gdi32" (ByVal hDestDC As Long, ByVal x As Long, ByVal y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal hSrcDC As Long, ByVal xSrc As Long, ByVal ySrc As Long, ByVal dwRop As Long) As Long
Private Declare Function CreateCompatibleDC Lib "gdi32" (ByVal hdc As Long) As Long
Private Declare Function SelectObject Lib "gdi32" (ByVal hdc As Long, ByVal hObject As Long) As Long
Private Const LR_CREATEDIBSECTION = 8192
Private Const LR_SHARED = &H8000
Private Const SRCCOPY = &HCC0020

Private Declare Function TextOut Lib "gdi32" Alias "TextOutA" (ByVal hdc As Long, ByVal x As Long, ByVal y As Long, ByVal lpString As String, ByVal nCount As Long) As Long
'END WIN32 API SECTION

Private PrimarySurf As DirectDrawSurface7
Private SecondarySurf As DirectDrawSurface7
Private strsurf As DDSURFACEDESC2
Private strsurfsec As DDSCAPS2
Private objDirectX As DirectX7
Private objDirectDraw As DirectDraw7
Private DdsdSecond As DDSURFACEDESC2
Public Function ImageToSurface(sr As DirectDrawSurface7, rID As Long) As Boolean
On Error GoTo Errors:

    DirectDraw.Picture1.Picture = LoadResPicture(rID, vbResBitmap)
    
    a = sr.GetDC
    hCompt = CreateCompatibleDC(a)
    SelectObject hCompt, DirectDraw.Picture1.Picture
    BitBlt a, 0, 0, 640, 480, hCompt, 0, 0, SRCCOPY

    sr.ReleaseDC (a)
    Debug.Print DirectDraw.Picture1.Image

    ImageToSurface = True
    Exit Function
Errors:
ImageToSurface = False
End Function

Public Function Flips() As Boolean
On Error GoTo Errors:
    PrimarySurf.Flip Nothing, DDFLIP_WAIT
    Flips = True
    Exit Function
Errors:
Flips = False
End Function

Public Function ClearSurfSecond() As Boolean
On Error GoTo Errors:

 '  Dim tempRECT As RECT
  '  Dim MyArray() As Byte
    
   ' SecondarySurf.Lock tempRECT, DdsdSecond, DDLOCK_WAIT Or DDLOCK_SURFACEMEMORYPTR, 0
    '      ,  
   ' SecondarySurf.GetLockedArray MyArray()
   ' For x = 0 To DdsdSecond.lWidth - 1
   ' For y = 0 To DdsdSecond.lHeight - 1
   ' MyArray(x, y) = 0
   ' Next y
   ' Next x
    '   SecondarySurf.Unlock tempRECT
    
     ClearSurfSecond = ImageToSurface(SecondarySurf, 101)
   
    Exit Function
Errors:
ClearSurfSecond = False
End Function

Public Function GetSecondarySurf() As Boolean
On Error GoTo Errors:
    strsurfsec.lCaps = DDSCAPS_BACKBUFFER
    Set SecondarySurf = PrimarySurf.GetAttachedSurface(strsurfsec)
    GetSecondarySurf = True
     Exit Function
Errors:
GetSecondarySurf = False
End Function

Public Function CreatePrimarySurf() As Boolean
On Error GoTo Errors:
 strsurf.lFlags = DDSD_CAPS Or DDSD_BACKBUFFERCOUNT
 strsurf.ddsCaps.lCaps = DDSCAPS_PRIMARYSURFACE Or DDSCAPS_FLIP Or DDSCAPS_COMPLEX
 strsurf.lBackBufferCount = 1
 Set PrimarySurf = objDirectDraw.CreateSurface(strsurf)
 CreatePrimarySurf = True
 Exit Function
Errors:
CreatePrimarySurf = False
End Function

Public Function SetMode640_480_8() As Boolean
On Error GoTo Errors:
 objDirectDraw.SetDisplayMode 640, 480, 8, 0, DDSDM_DEFAULT
 SetMode640_480_8 = True
 Exit Function
Errors:
  SetMode640_480_8 = False
End Function

Public Function GetFullScreenCooperativeLevel() As Boolean
On Error GoTo Errors:
    objDirectDraw.SetCooperativeLevel DirectDraw.hWnd, DDSCL_FULLSCREEN Or DDSCL_EXCLUSIVE
    GetFullScreenCooperativeLevel = True
    Exit Function
Errors:
  GetFullScreenCooperativeLevel = False
End Function



Public Function InitDirectDraw() As Boolean
On Error GoTo Errors:
    Set objDirectX = New DirectX7
    Set objDirectDraw = objDirectX.DirectDrawCreate("")
    InitDirectDraw = True
    Exit Function
Errors:
  InitDirectDraw = False
End Function



Private Sub Class_Terminate()
objDirectDraw.RestoreDisplayMode
objDirectDraw.SetCooperativeLevel 0, DDSCL_NORMAL
Set SecondarySurf = Nothing
Set PrimarySurf = Nothing
Set objDirectDraw = Nothing
Set objDirectX = Nothing
End Sub
